// AttrListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HDAClientTest.h"
#include "AttrListDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAttrListDlg dialog


CAttrListDlg::CAttrListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAttrListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAttrListDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CAttrListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAttrListDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAttrListDlg, CDialog)
	//{{AFX_MSG_MAP(CAttrListDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAttrListDlg message handlers

BOOL CAttrListDlg::OnInitDialog() 
{
	CListCtrl *pList;
	CRect	rect;
	LV_COLUMN		lvcolumn;
	ATTRDESCR	*pAttr;
	int	i;

	CDialog::OnInitDialog();
	
	pList = (CListCtrl *)GetDlgItem (IDC_LIST1);

	pList->GetWindowRect(&rect);

	lvcolumn.mask = LVCF_FMT |  LVCF_TEXT | LVCF_WIDTH;
	lvcolumn.fmt = LVCFMT_LEFT;
	lvcolumn.pszText = "Id";
	lvcolumn.iSubItem = 0;
	lvcolumn.cx = rect.Width()/4;
	pList->InsertColumn(0, &lvcolumn);  // assumes return value is OK.

	lvcolumn.pszText = "Name";
	lvcolumn.iSubItem = 1;
	lvcolumn.cx = rect.Width()/4;
	pList->InsertColumn(1, &lvcolumn);

	lvcolumn.pszText = "Description";
	lvcolumn.iSubItem = 2;
	lvcolumn.cx = rect.Width()/4;
	pList->InsertColumn(2, &lvcolumn);

	if (m_IsAggregates)
		SetWindowText ("Supported HDA Aggregates");
	else 
		{
		lvcolumn.pszText = "VarType";
		lvcolumn.iSubItem = 3;
		lvcolumn.cx = rect.Width()/4;
		pList->InsertColumn(3, &lvcolumn);
		}

	for (i=0; i<m_pAttrs->GetSize(); i++)
		{
		pAttr = (ATTRDESCR *)m_pAttrs->GetAt(i);
		AddAttribute (pAttr->Id, pAttr->Name, pAttr->Description, pAttr->vt);
		}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CAttrListDlg::AddAttribute (DWORD Id, CString Name, CString Description, VARTYPE vt)
{
	CListCtrl *pList;
	LV_ITEM		lvitem;
	char	buf[400];
	int		index;

	pList = (CListCtrl *)GetDlgItem (IDC_LIST1);

	index = pList->GetItemCount();
	lvitem.mask = LVIF_TEXT | LVIF_STATE;
	lvitem.iItem = index;
	lvitem.iSubItem = 0;
	sprintf (buf, "%d", Id);
	lvitem.pszText = buf;
	lvitem.state = 0;
	lvitem.stateMask = LVIS_STATEIMAGEMASK;
	pList->InsertItem(&lvitem);

	pList->SetItemText(index,1,Name);
	pList->SetItemText(index,2,Description);
	if (!m_IsAggregates)
		{
		switch (vt)
			{
			case VT_I2:
				pList->SetItemText(index,3,"VT_I2");
				break;
			case VT_I4:
				pList->SetItemText(index,3,"VT_I4");
				break;
			case VT_R4:
				pList->SetItemText(index,3,"VT_R4");
				break;
			case VT_R8:
				pList->SetItemText(index,3,"VT_R8");
				break;
			case VT_DATE:
				pList->SetItemText(index,3,"VT_DATE");
				break;
			case VT_BSTR:
				pList->SetItemText(index,3,"VT_BSTR");
				break;
			case VT_BOOL:
				pList->SetItemText(index,3,"VT_BOOL");
				break;
			case VT_UI1:
				pList->SetItemText(index,3,"VT_UI2");
				break;
			default:
				sprintf (buf, "%d", vt);
				pList->SetItemText(index,3,buf);
				break;
			}
		}

	pList->RedrawItems(index,index);

	return (TRUE);
}

