// DataValuesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HDAClientTest.h"
#include "DataValuesDlg.h"
#include "opchda.h"
#include "opcda.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDataValuesDlg dialog


CDataValuesDlg::CDataValuesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDataValuesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDataValuesDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDataValuesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDataValuesDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDataValuesDlg, CDialog)
	//{{AFX_MSG_MAP(CDataValuesDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDataValuesDlg message handlers

BOOL CDataValuesDlg::OnInitDialog() 
{
	CListCtrl	*pList;
	CRect	rect;
	LV_COLUMN		lvcolumn;
	LV_ITEM		lvitem;
	DWORD	i;
	CTime	ctime;
	char buf[400];

	CDialog::OnInitDialog();

	if (m_IsRawData)
		SetWindowText ("HDA Raw Data Values");

	pList = (CListCtrl *)GetDlgItem (IDC_LIST1);

	pList->GetWindowRect(&rect);

	lvcolumn.mask = LVCF_FMT |  LVCF_TEXT | LVCF_WIDTH;
	lvcolumn.fmt = LVCFMT_LEFT;
	lvcolumn.pszText = "TimeStamp";
	lvcolumn.iSubItem = 0;
	lvcolumn.cx = rect.Width()/3;
	pList->InsertColumn(0, &lvcolumn);  // assumes return value is OK.

	lvcolumn.pszText = "Value";
	lvcolumn.iSubItem = 1;
	lvcolumn.cx = rect.Width()/3;
	pList->InsertColumn(1, &lvcolumn);

	lvcolumn.pszText = "Quality";
	lvcolumn.iSubItem = 2;
	lvcolumn.cx = rect.Width()/3;
	pList->InsertColumn(2, &lvcolumn);

	for (i=0; i<Numbr; i++)
		{
		lvitem.mask = LVIF_TEXT | LVIF_STATE;
		lvitem.iItem = i;
		lvitem.iSubItem = 0;
		ctime = pTimeStamps[i];
		strncpy (buf, ctime.Format("%H:%M:%S %d-%b-%Y"), 400);
		lvitem.pszText = buf;
		lvitem.state = 0;
		lvitem.stateMask = LVIS_STATEIMAGEMASK;
		pList->InsertItem(&lvitem);

		pList->SetItemText(i,1,FormatVariant(&(pValues[i])));
		pList->SetItemText(i,2,FormatQualityString(pQualities[i]));
		}

	pList->RedrawItems(0,Numbr);

	
	// TODO: Add extra initialization here	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

CString  CDataValuesDlg::FormatVariant(VARIANT *pValue) 
{
	char	buf[80];

	switch(pValue->vt)
		{
		case VT_I1:
		case VT_UI1:		// BYTE
			sprintf (buf, "%d ", pValue->bVal );
			break;
		case VT_I2:			// SHORT
			sprintf	(buf, "%d ", pValue->iVal );
			break;
		case VT_UI2:		// UNSIGNED SHORT
			sprintf	(buf, "%d ", pValue->uiVal );
			break;
		case VT_I4:			// LONG
			sprintf	(buf, "%ld ", pValue->lVal );
			break;
		case VT_UI4:		// UNSIGNED LONG
			sprintf	(buf, "%ld ", pValue->ulVal );
			break;
		case VT_INT:		// INTEGER
			sprintf	(buf, "%ld ", pValue->intVal );
			break;
		case VT_UINT:		// UNSIGNED INTEGER
			sprintf	(buf, "%ld ", pValue->uintVal );
			break;
		case VT_R4:			// FLOAT
			sprintf	(buf, "%5.2f ", pValue->fltVal );
			break;
		case VT_R8:			// DOUBLE
			sprintf	(buf, "%9.4f ", pValue->dblVal );
			break;
		case VT_BSTR:		//BSTR
			sprintf	(buf, "%ls ", pValue->bstrVal );
			break;
		case VT_BOOL:
			if (pValue->boolVal)
				strcpy (buf, "TRUE");
			else
				strcpy (buf, "FALSE");
			break;
		default:
			sprintf	(buf, " unknown type:%d ", pValue->vt );
			break;
		}
	return (buf);
}

CString  CDataValuesDlg::FormatQualityString(DWORD Quality) 
{
	char buf[100];

	sprintf (buf, "0x%x", Quality);
	return (buf);

	if (Quality == OPCHDA_INTERPOLATED)
		return ("OPCHDA_INTERPOLATED");
	if (Quality == OPCHDA_RAW)
		return ("OPCHDA_RAW");
	if (Quality == OPCHDA_CALCULATED)
		return ("OPCHDA_CALCULATED");
	if (Quality == OPCHDA_NOBOUND)
		return ("OPCHDA_NOBOUND");
	if (Quality == OPCHDA_NODATA)
		return ("OPCHDA_NODATA");
	if (Quality == OPCHDA_DATALOST)
		return ("OPCHDA_DATALOST");
	if (Quality == OPCHDA_CONVERSION)
		return ("OPCHDA_CONVERSION");
	if (Quality == OPCHDA_EXTRADATA)
		return ("OPCHDA_EXTRADATA");
	if (Quality == OPC_QUALITY_GOOD)
		return ("OPC_QUALITY_GOOD");
	if (Quality == OPC_QUALITY_BAD)
		return ("OPC_QUALITY_BAD");
	if (Quality == OPC_QUALITY_UNCERTAIN)
		return ("OPC_QUALITY_UNCERTAIN");

	sprintf (buf, "0x%x", Quality);
	return (buf);
}
