// HDAClientTestView.h : interface of the CHDAClientTestView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_HDACLIENTTESTVIEW_H__378DDD3C_5572_41F0_B7A4_FA34D440A25B__INCLUDED_)
#define AFX_HDACLIENTTESTVIEW_H__378DDD3C_5572_41F0_B7A4_FA34D440A25B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CHDAClientTestView : public CListView
{
protected: // create from serialization only
	CHDAClientTestView();
	DECLARE_DYNCREATE(CHDAClientTestView)

// Attributes
public:
	CString		MachineName, ServerName;
	HANDLE		ConnectionHandle;
	DWORD		ItemReferenceCount;
	CObArray	ConnectedItemList;

	void	OnConnect(); 
	void	OnOpcserverConnect(); 

	CHDAClientTestDoc* GetDocument();
	CHDAClientTestApp *GetApp();

	void	AddNewItem (CString ItemName, CString Access);
	void	RemoveAllConnectedItems();
	void	InitItemListCtrl();
	CString	FormatVariant (VARIANT *pValue);

// Operations
public:

	afx_msg LRESULT OnShutdownRequest(UINT wParam, LPARAM	lParam);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHDAClientTestView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CHDAClientTestView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CHDAClientTestView)
	afx_msg void OnHdaitemBrowse();
	afx_msg void OnUpdateHdaitemBrowse(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnDisconnect();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnConnectLocal();
	afx_msg void OnUpdateConnectLocal(CCmdUI* pCmdUI);
	afx_msg void OnConnectRemote();
	afx_msg void OnUpdateConnectRemote(CCmdUI* pCmdUI);
	afx_msg void OnUpdateHdaitemRemove(CCmdUI* pCmdUI);
	afx_msg void OnHdaitemRemove();
	afx_msg void OnDestroy();
	afx_msg void OnUpdateHdaserverAggregates(CCmdUI* pCmdUI);
	afx_msg void OnUpdateHdaserverAttributes(CCmdUI* pCmdUI);
	afx_msg void OnHdaserverAggregates();
	afx_msg void OnHdaserverAttributes();
	afx_msg void OnUpdateHdaitemHistoryRawdata(CCmdUI* pCmdUI);
	afx_msg void OnHdaitemHistoryRawdata();
	afx_msg void OnHdaitemHistoryProcessed();
	afx_msg void OnUpdateHdaitemHistoryProcessed(CCmdUI* pCmdUI);
	afx_msg void OnOpcserverStatus();
	afx_msg void OnUpdateOpcserverStatus(CCmdUI* pCmdUI);
	afx_msg void OnHdaitemAdd();
	afx_msg void OnUpdateHdaitemAdd(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in HDAClientTestView.cpp
inline CHDAClientTestDoc* CHDAClientTestView::GetDocument()
   { return (CHDAClientTestDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HDACLIENTTESTVIEW_H__378DDD3C_5572_41F0_B7A4_FA34D440A25B__INCLUDED_)
