Attribute VB_Name = "OPC_Declarations"

Public Type CByteArrayType
    chrdata(400) As Byte
    End Type
   
' WTHDAClientRevision()
' This function simply returns a WORD revision indication
Declare Function WtHDAClientRevision Lib "WtHDAclient" Alias "_WtHDAClientRevision@0" () As Integer
'
' WtHDAClientCoInit()
' This function initializes DCOM using default security settings
Declare Function WtHDAClientCoInit Lib "WtHDAclient" Alias "_WtHDAClientCoInit@0" () As Long
'
' NumberOfHDAServers(...)
' returns the number of available OPC servers
Declare Function NumberOfHDAServers Lib "WtHDAclient" Alias "_NumberOfHDAServers@4" (MachineName As Byte) As Long
'
' GetHDAServerName(...)
' Used to iterate through the server list obtained with NumberOfHDAServers()
' User Buffer pointed to by pBuf is filled with the Server name at index of the Server List
' A returned value of 0, (FALSE), indicates that the index is invalid.
Declare Function GetHDAServerName Lib "WtHDAclient" Alias "_GetHDAServerName@12" (ByVal index As Long, ByRef Buffer As Byte, ByVal BufSize As Long) As Long
'
' ConnectHDA (...)
' Establishes an OPC Connection with the specified server
' INVALID_HANDLE_VALUE (-1) is returned if the connection cannot be established.
Declare Function ConnectHDA Lib "WtHDAclient" Alias "_ConnectHDA@8" (ByRef MachineName As Byte, ByRef ServerName As Byte) As Long
'
' DisconnectHDA(...)
' Used to shutdown an HDA Connection
Declare Function DisconnectHDA Lib "WtHDAclient" Alias "_DisconnectHDA@4" (ByVal hConnect As Long) As Long
'
' NumberOfHDAAttributes(...)
' Returns the number of Item Attributes supported by the server
' This function fills an internal array of Attribute Descriptions
' which may then be accessed via GetHDAAttributeDescr().
Declare Function NumberOfHDAAttributes Lib "WtHDAclient" Alias "_NumberOfHDAAttributes@4" (ByVal hConnect As Long) As Long
'
' GetHDAAttributeDescr(...)
' Allows user to iterate through the list of Attribute Descriptions obtained from
' NumberOfHDAAttributes().
'
Declare Function GetHDAAttributeDescr Lib "WtHDAclient" Alias "_GetHDAAttributeDescr@32" (ByVal hConnect As Long, ByVal index As Long, ByRef AttrID As Long, ByRef VT As Long, ByRef NameBuf As Byte, ByVal BufSize As Long, ByRef DescBuf As Byte, ByVal dBufSize As Long) As Long
'
' NumberOfHDAAggregates(...)
' Returns the number of Item Aggregates supported by the server
' This function fills an internal array of Aggregate Descriptions
' which may then be accessed via GetHDAAggregateDescr().
'
Declare Function NumberOfHDAAggregates Lib "WtHDAclient" Alias "_NumberOfHDAAggregates@4" (ByVal hConnect As Long) As Long

' GetHDAAggregateDescr(...)
' Allows user to iterate through the list of Aggregate Descriptions obtained from
' NumberOfHDAAttributes().
'
Declare Function GetHDAAggregateDescr Lib "WtHDAclient" Alias "_GetHDAAggregateDescr@28" (ByVal hConnect As Long, ByVal index As Long, ByRef AggrId As Long, ByRef NameBuf As Byte, ByVal BufSize As Long, ByRef DescBuf As Byte, ByVal dBufSize As Long) As Long
'
' NumberOfHDAItems(...)
' Returns the number of OPC HDA Items from the Browse Interface of the designated
' Server connection.  If the server does not support Browsing, a value of xero
' is returned.  This function fills an internal array of itemnames which may
' then be accessed via GetHDAItemName().
' This function is equivalent to calling the HDA Browser using a
' universal filter, (OPCHDA_ITEMID+OPCHDA_EQUAL+'*'), for  HDA Items
' using OPC_FLAT from the Root position.
Declare Function NumberOfHDAItems Lib "WtHDAclient" Alias "_NumberOfHDAItems@4" (ByVal hConnect As Long) As Long
'
' GetHDAItemName(...)
' Allows user to iterate through the list of item names obtained from
' NumberOfHDAItems().
'
Declare Function GetHDAItemName Lib "WtHDAclient" Alias "_GetHDAItemName@16" (ByVal hConnect As Long, ByVal index As Long, ByRef NameBuf As Byte, ByVal BufSize As Long) As Long
'
' GetHDAItemHandle(...)
' Returns the server handle for the defined item.
' The returned server handle must be used in all requests to read or update history.
Declare Function GetHDAItemHandle Lib "WtHDAclient" Alias "_GetHDAItemHandle@12" (ByVal hConnect As Long, ByRef ItemName As Byte, ByVal ClientHandle As Long) As Long
'
' ReleaseHDAItemHandle(...)
' Releases the HDA Server Handle for the connected item.
Declare Function ReleaseHDAItemHandle Lib "WtHDAclient" Alias "_ReleaseHDAItemHandle@8" (ByVal hConnect As Long, ByVal hItem As Long) As Long
'
' ReadHDAItemAttributes (...)
' Allows the application to read Attribute values for a connected HDA Item
' over the specifiied period of time.  The return value represents the
' number of Attribute values read.  If the MSB of the return value is set, it
' indicates that more data was available than would fit in the allocated buffer.
Declare Function ReadHDAItemAttributes Lib "WtHDAclient" Alias "_ReadHDAItemAttributesVB@32" (ByVal hConnect As Long, ByVal hItem As Long, ByVal AttrID As Long, ByRef StartTime As Date, ByRef EndTime As Date, ByVal MaxValues As Long, ByRef TimeStamps As Date, ByRef Values As Variant) As Long
'
' ReadHDAItemValues (...)
' Allows the application to read item values from the server
' over the specifiied period of time.  The return value represents the
' number of values read.  If the MSB of the return value is set, it
' indicates that more data was available than would fit in the allocated buffer.
Declare Function ReadHDAItemValues Lib "WtHDAclient" Alias "_ReadHDAItemValuesVB@36" (ByVal hConnect As Long, ByVal hItem As Long, ByVal GetBoundingValues As Long, ByRef StartTime As Date, ByRef EndTime As Date, ByVal MaxValues As Long, ByRef TimeStamps As Date, ByRef Values As Variant, ByRef Qualities As Long) As Long
'
' WriteHDAItemValues (...)
' Allows the application to write item values to the server
' using the optional SyncUpdate Interface.  The UpdateType parameter
' should be Insert,Replace, or InsertReplace, (1, 2. & 4 respectively).
' The return value is the HRESULT error code as returned from the connected HDA Server
Declare Function WriteHDAItemValues Lib "WtHDAclient" Alias "_WriteHDAItemValuesVB@32" (ByVal hConnect As Long, ByVal hItem As Long, ByVal UpdateType As Long, ByVal NumValues As Long, ByRef TimeStamps As Date, ByRef Values As Variant, ByRef Qualities As Long, ByRef HResult As Long) As Long
'
' ReadHDAProcessedItemValues (...)
' Allows the application to read calculated item values from the server
' over the specifiied period of time.  The return value represents the
' number of values read.  If the MSB of the return value is set, it
' indicates that more data was available than would fit in the allocated buffer.
Declare Function ReadHDAProcessedItemValues Lib "WtHDAclient" Alias "_ReadHDAProcessedItemValuesVB@40" (ByVal hConnect As Long, ByVal hItem As Long, ByVal AggregateID As Long, ByRef StartTime As Date, ByRef EndTime As Date, ByRef ReSampleInterval As Long, ByVal MaxValues As Long, ByRef TimeStamps As Date, ByRef Values As Variant, ByRef Qualities As Long) As Long '()



'
' EnableHDAErrorNotification(...)
' Establishes a callback function in the user application which will receive
' control when an error is detected by the dll.  If this callback is not used
' errors will generate a modal MessageBox which must be acknowledged by the user)
' 'C' prototype for the callback function is as follows:
'      void CALLBACK EXPORT ErrorMsgCallback (DWORD hResult, char *pMsg)
' (the buffer supplied by the dll as pMsg is a temporary and data should be
'  copied to a permanant buffer by the application)
'  (See ErrorNotificationCallback Sub Declaration below)
Declare Function EnableHDAErrorNotification Lib "WtHDAclient" Alias "_EnableHDAErrorNotification@4" (ByVal lpFunction As Long) As Long
'
' EnableHDAShutdownNotification(...)
' Establishes a callback to the application if the connected
' server requests a disconnect;
'  (See ShutdownNotificationCallback Sub Declaration below)
Declare Function EnableHDAShutdownNotification Lib "WtHDAclient" Alias "_EnableHDAShutdownNotification@8" (ByVal hConnect As Long, ByVal lpFunction As Long) As Long
'
' EnableHDAEventMessages(...)
' Establishes a callback to the application for displaying
' Debug DCOM Event Messages.  A character buffer is returned as a parameter
' that contains a textual description of the message.
' 'C' prototype for the callback function is as follows:
'      void CALLBACK EXPORT EventMsgCallback (char *pMsg)
' (the buffer supplied by the dll as pMsg is a temporary and data should be
'  copied to a permanant buffer by the application)
'  (See EventNotificationCallback Sub Declaration below)
Declare Function EnableHDAEventMessages Lib "WtHDAclient" Alias "_EnableHDAEventMsgs@4" (ByVal lpFunction As Long) As Long
'
' DisableHDA30MinTimer(...)
Declare Function DisableHDA30MinTimer Lib "WtHDAclient" Alias "_DisableHDA30MinTimer@4" (ByRef AccessCode As Byte) As Long



Sub ErrorNotificationCallback(ByVal ErrorCode As Long, ByRef ErrorText As CByteArrayType)
    Dim MyDescrip As String
    Dim j As Integer
    
    For j = 0 To 400
        MyDescrip = MyDescrip + Chr(ErrorText.chrdata(j))
        Next j
        
    frmMain.lstEvents.AddItem (MyDescrip)

End Sub

Sub EventNotificationCallback(ByRef ErrorText As CByteArrayType)
    Dim MyDescrip As String
    Dim j As Integer
    
    For j = 0 To 400
        MyDescrip = MyDescrip + Chr(ErrorText.chrdata(j))
        Next j
        
    frmMain.lstEvents.AddItem (MyDescrip)

End Sub


Sub ShutdownNotificationCallback(ByVal hConnect As Long)


End Sub

